com.io7m.smfj.bytebuffer

## Interface SMFByteBufferPackingConfigurationType

- All Known Implementing Classes:
    SMFByteBufferPackingConfiguration

      public interface SMFByteBufferPackingConfigurationType

  The byte buffer packing configuration.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `javaslang.collection.Seq<SMFAttribute>` | `attributesOrdered()` A specification of the sequence of attributes that will be packed into the byte buffer.
    `default void` | `checkPreconditions()` Check preconditions for the type.
    `default long` | `offsetOctetsForIndex(int index, long vertex)` Determine the offset in octets of the attribute with order `index` at vertex `vertex`.
    `default javaslang.collection.SortedMap<SMFAttributeName,SMFByteBufferPackedAttribute>` | `packedAttributesByName()`
    `default javaslang.collection.SortedMap<Integer,SMFByteBufferPackedAttribute>` | `packedAttributesByOffset()`
    `default javaslang.collection.Seq<SMFByteBufferPackedAttribute>` | `packedAttributesByOrder()`
    `default int` | `vertexSizeOctets()`

- - ### Method Detail

    - #### attributesOrdered

          javaslang.collection.Seq<SMFAttribute> attributesOrdered()

      A specification of the sequence of attributes that will be packed into the byte buffer. For each vertex in turn, the value of each attribute will be packed (interleaved) into the buffer in the order given by this sequence.
      Returns:
        The sequence of attributes that will be packed into the byte buffer

    - #### packedAttributesByOffset

          default javaslang.collection.SortedMap<Integer,SMFByteBufferPackedAttribute> packedAttributesByOffset()

      Returns:
        The packed attributes by octet offset

    - #### packedAttributesByOrder

          default javaslang.collection.Seq<SMFByteBufferPackedAttribute> packedAttributesByOrder()

      Returns:
        The packed attributes in declaration order

    - #### packedAttributesByName

          default javaslang.collection.SortedMap<SMFAttributeName,SMFByteBufferPackedAttribute> packedAttributesByName()

      Returns:
        The packed attributes by name

    - #### offsetOctetsForIndex

          default long offsetOctetsForIndex(int index,
                                            long vertex)

      Determine the offset in octets of the attribute with order `index` at vertex `vertex`.
      Parameters:
        `index` - The attribute index
        `vertex` - The vertex index
      Returns:
        The offset in octets

    - #### vertexSizeOctets

          default int vertexSizeOctets()

      Returns:
        The size of one vertex in octets

    - #### checkPreconditions

          default void checkPreconditions()

      Check preconditions for the type.

Copyright © 2017 <code@io7m.com> http://io7m.com